--[[
    Broker_BattlegroundFu by LordFarlander
    Version 3.0.6
    $Revision: 6 $

    A conversion of Fubar_BattlegroundFu by Mynithrosil of Feathermoon
]]--

--[[
Copyright (c) 2008-2009, LordFarlander
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
]]--

Broker_BattlegroundFu = LibStub( "AceAddon-3.0" ):NewAddon( "Broker_BattlegroundFu", "AceEvent-3.0", "AceConsole-3.0", "AceTimer-3.0" );

Broker_BattlegroundFu.version = "3.0." .. "6";
Broker_BattlegroundFu.date    = ("$Date: 2009-01-09 03:04:41 +0000 (Fri, 09 Jan 2009) $"):sub( 8, 17 );

local Abacus  = LibStub( "LibAbacus-3.0" );
local Dewdrop = LibStub( "Dewdrop-2.0" );
local Glory   = LibStub( "LibLordFarlander-Glory-3.0" );
local L       = LibStub( "AceLocale-3.0" ):GetLocale( "Broker_BattlegroundFu" );
local qtip    = LibStub( "LibQTip-1.0" );
local Crayon  = LibStub( "LibCrayon-3.0" );
local Z       = LibStub( "LibBabble-Zone-3.0" ):GetLookupTable();

local playerFaction = UnitFactionGroup( "player" );
local FACTION_ICON_PATH = "Interface\\AddOns\\Broker_BattlegroundFu\\icons\\Icon";
local NOQUEUE_ICON_SUFFIX = "_grey";

local ObjectiveClickProvider, ObjectiveClickPrototype, baseObjectiveClickCellPrototype = qtip:CreateCellProvider( qtip.LabelProvider );

function ObjectiveClickProvider:InitializeCell()
    baseObjectiveClickCellPrototype.InitializeCell( self );
end--ObjectiveClickProvider:InitializeCell()

function ObjectiveClickPrototype:SetupCell( tooltip, value, justification, font, factionAttacking, node, status )
    self:EnableMouse( true );
    self:SetScript( "OnEnter", function( self )
                                   if( not self.highlight ) then
                                       self.highlight = self:CreateTexture( nil, "BACKGROUND" );
                                       self.highlight:Hide();
                                   end--if
                                   self.highlight:SetTexture( "Interface\\QuestFrame\\UI-QuestTitleHighlight" );
                                   self.highlight:SetBlendMode( "ADD" );
                                   self.highlight:SetAllPoints( self );
                                   self.highlight:Show();
                               end );
    self:SetScript( "OnLeave", function( self )
                                   self.highlight:ClearAllPoints();
                                   self.highlight:Hide();
                               end );
    self:SetScript( "OnMouseDown", function()
                                       if factionAttacking then
                                           SendChatMessage( "(" .. factionAttacking .. ") " .. node .. " T: " .. status, "BATTLEGROUND" );
                                       end--if
                                 end );
    return baseObjectiveClickCellPrototype.SetupCell( self, tooltip, value, justification, font );
end--ObjectiveClickPrototype:SetupCell( tooltip, value, justification, font )

Broker_BattlegroundFu.vars = {};

--User Options Methods=========================================================
function Broker_BattlegroundFu:IsHidingMinimapButton()
    return self.db.profile.hideMinimapButton;
end--Broker_BattlegroundFu:IsHidingMinimapButton()

function Broker_BattlegroundFu:IsHidingBattleFrame()
    return self.db.profile.hideBattleFrame;
end--Broker_BattlegroundFu:IsHidingBattleFrame()

function Broker_BattlegroundFu:IsAutoReleasing()
    return self.db.profile.autoRelease;
end--Broker_BattlegroundFu:IsAutoReleasing()

function Broker_BattlegroundFu:IsInvertQueueProgress()
    return self.db.profile.invertQueueProgress;
end--Broker_BattlegroundFu:IsInvertQueueProgress()

function Broker_BattlegroundFu:IsClickShowsScoreboard()
    return self.db.profile.clickShowsScoreboard;
end--Broker_BattlegroundFu:IsClickShowsScoreboard()

function Broker_BattlegroundFu:IsShowingTeamSizes()
    return self.db.profile.showTeamSizes;
end--Broker_BattlegroundFu:IsShowingTeamSizes()

function Broker_BattlegroundFu:IsShowingTeamScores()
    return self.db.profile.showTeamScores;
end--Broker_BattlegroundFu:IsShowingTeamScores()

function Broker_BattlegroundFu:IsShowingNumBases()
    return self.db.profile.showNumBases;
end--Broker_BattlegroundFu:IsShowingNumBases()

function Broker_BattlegroundFu:IsShowingResourceTTV()
    return self.db.profile.showResourceTTV;
end--Broker_BattlegroundFu:IsShowingResourceTTV()

function Broker_BattlegroundFu:IsShowingPlayerStats()
    return self.db.profile.showPlayerStats;
end--Broker_BattlegroundFu:IsShowingPlayerStats()

function Broker_BattlegroundFu:IsShowingObjectiveStatus()
    return self.db.profile.showObjectiveStatus;
end--Broker_BattlegroundFu:IsShowingObjectiveStatus()

function Broker_BattlegroundFu:IsShowingUncontestedObjectives()
    return self.db.profile.showUncontestedObjectives;
end--Broker_BattlegroundFu:IsShowingUncontestedObjectives()

function Broker_BattlegroundFu:IsShowingCTFFlagCarriers()
    return self.db.profile.showCTFFlagCarriers;
end--Broker_BattlegroundFu:IsShowingCTFFlagCarriers()

function Broker_BattlegroundFu:IsShowingQueues()
    return self.db.profile.showQueues;
end--Broker_BattlegroundFu:IsShowingQueues()

function Broker_BattlegroundFu:IsNoQueueText()
    return self.db.profile.noQueueText;
end--Broker_BattlegroundFu:IsNoQueueText()

function Broker_BattlegroundFu:IsHidingQueueText( q )
    return self.db.profile.hideQueueText[q];
end--Broker_BattlegroundFu:IsHidingQueueText( q )

function Broker_BattlegroundFu:ToggleHidingQueueText( q )
    self.db.profile.hideQueueText[q] = not self.db.profile.hideQueueText[q];
    self:OnTextUpdate();
end--Broker_BattlegroundFu:ToggleHidingQueueText( q )

--End User Options Methods=====================================================

function Broker_BattlegroundFu:OnInitialize()
    local AceConfigReg = LibStub( "AceConfigRegistry-3.0" );
    local AceConfigDialog = LibStub( "AceConfigDialog-3.0" );
    local defaults = {
        profile = {
            hideMinimapButton               =   false,
            invertQueueProgress             =   false,
            clickShowsScoreboard            =   false,
            hideBattleFrame                 =   false,
            autoRelease                     =   false,
            showTeamSizes                   =   true,
            showTeamScores                  =   true,
            showNumBases                    =   true,
            showResourceTTV                 =   true,
            showObjectiveStatus             =   true,
            showUncontestedObjectives       =   true,
            showCTFFlagCarriers             =   true,
            showPlayerStats                 =   true,
            showQueues                      =   true,
            noQueueText                     =   true,
            hideQueueText                   =   {},
        },
    };
    local options = {
        type = "group",
        handler = self,
        args = {
            minimap = {
                type = "toggle",
                name = L["Hide minimap button"],
                desc = L["Toggle display of the Battlegrounds minimap button"],
                get  = "IsHidingMinimapButton",
                set  = function( info, value )
                           info.handler.db.profile.hideMinimapButton = value;
                           if( value ) then
                               MiniMapBattlefieldFrame:Hide();
                           else
                               MiniMapBattlefieldFrame:Show();
                           end--if
                       end,
            },
            battleframe = {
                type = "toggle",
                name = L["Hide default battle objectives frame"],
                desc = L["Toggle display of the default battle objectives frame"],
                get  = "IsHidingBattleFrame",
                set  = function( info, value )
                           info.handler.db.profile.hideBattleFrame = value;
                           if( value ) then
                               WorldStateAlwaysUpFrame:Hide()
                           else
                               WorldStateAlwaysUpFrame:Show()
                           end--if
                       end,
            },
            autoRelease = {
                type = "toggle",
                name = L["Auto-release when dead"],
                desc = L["Toggle whether to automatically release when dead in battlegrounds"],
                get = "IsAutoReleasing",
                set = function( info, value )
                          info.handler.db.profile.autoRelease = value;
                      end,
            },
            invert = {
                type = "toggle",
                name = L["Inverted queue timers"],
                desc = L["Toggle whether BatFu's queue timer displays count down from the estimated queue duration or up from zero."],
                get  = "IsInvertQueueProgress",
                set  = function( info, value )
                           info.handler.db.profile.invertQueueProgress = value;
                           info.handler:UpdateDisplay();
                       end,
            },
            clickscores = {
                type = "toggle",
                name = L["Click displays scoreboard"],
                desc = L["Toggle in-battle behavior for clicking on the BatFu plugin (scoreboard only/scoreboard and battlefield instance frames)."],
                get  = "IsClickShowsScoreboard",
                set  = function( info, value )
                           info.handler.db.profile.clickShowsScoreboard = value;
                           info.handler:UpdateDisplay();
                       end,
            },
            noqueuetext = {
                type = "toggle",
                name = L["Show Text When No Queues"],
                desc = L["Toggle display of 'No Queues' when you are not queued and not inside a battleground."],
                get  = "IsNoQueueText",
                set  = function( info, value )
                           info.handler.db.profile.noQueueText = value;
                           info.handler:OnTextUpdate();
                       end,
            },
        },
    };
    local tooltipOptions = {
        type = "group",
        name = L["Tooltip Options"],
        desc = L["Toggles display of elements of the tooltip."],
        args = {
            teamsizes = {
                type = "toggle",
                name = L["Team sizes"],
                desc = L["Toggle the Team Size line on the in-battle tooltip."],
                get  = "IsShowingTeamSizes",
                set  = function( info, value )
                           info.handler.db.profile.showTeamSizes = value;
                           info.handler:UpdateTooltip();
                       end,
            },
            teamscores = {
                type = "toggle",
                name = L["Team scores"],
                desc = L["Toggle the Team Score line on the in-battle tooltip."],
                get  = "IsShowingTeamScores",
                set  = function( info, value )
                           info.handler.db.profile.showTeamScores = value;
                           info.handler:UpdateTooltip();
                       end,
            },
            bases = {
                type = "toggle",
                name = L["Bases held"],
                desc = L["Toggle the Bases Held line on the in-battle tooltip."],
                get  = "IsShowingNumBases",
                set  = function( info, value )
                           info.handler.db.profile.showNumBases = value;
                           info.handler:UpdateTooltip();
                       end,
            },
            ttv = {
                type = "toggle",
                name = L["Time-to-victory"],
                desc = L["Toggle the Time-To-Victory (TTV) line on the in-battle tooltip (for resource collection Battlegrounds)."],
                get  = "IsShowingResourceTTV",
                set  = function( info, value )
                           info.handler.db.profile.showResourceTTV = value;
                           info.handler:UpdateTooltip();
                       end,
            },
            stats = {
                type = "toggle",
                name = L["Player stats"],
                desc = L["Toggle the player statistics (kills, deaths, killing blows, bonus honor) on the in-battle tooltip."],
                get  = "IsShowingPlayerStats",
                set  = function( info, value )
                           info.handler.db.profile.showPlayerStats = value;
                           info.handler:UpdateTooltip();
                       end,
            },
            objectives = {
                type = "toggle",
                name = L["Objective status"],
                desc = L["Toggle the display of objective status (node controllers, capture timers, etc.) on the in-battle tooltip."],
                get  = "IsShowingObjectiveStatus",
                set  = function( info, value )
                           info.handler.db.profile.showObjectiveStatus = value;
                           info.handler:UpdateTooltip();
                       end,
            },
            uncontested = {
                type = "toggle",
                name = L["Uncontested objectives"],
                desc = L["Show only the status of those nodes which are currently in conflict or not yet claimed."],
                get  = "IsShowingUncontestedObjectives",
                set  = function( info, value )
                           info.handler.db.profile.showUncontestedObjectives = value;
                           info.handler:UpdateTooltip();
                       end,
            },
            flags = {
                type = "toggle",
                name = L["Flag Carriers"],
                desc = L["Toggle click-to-target (alt-click if tooltip is locked) display of CTF flag carriers on the in-battle tooltip."],
                get  = "IsShowingCTFFlagCarriers",
                set  = function( info, value )
                           info.handler.db.profile.showCTFFlagCarriers = value;
                           info.handler:UpdateTooltip();
                       end,
            },
            queues = {
                type = "toggle",
                name = L["Queues"],
                desc = L["Toggle display of pending battlefield queues on the tooltip."],
                get  = "IsShowingQueues",
                set  = function( info, value )
                           info.handler.db.profile.showQueues = value;
                           info.handler:UpdateTooltip();
                       end,
            },
        },
    };
    
    if( BattlegroundFu ) then
        options.args.copysettings = {
            type = "execute",
            order = -1,
            name = L["Copy setting from FuBar_BattlegroundFu"],
            desc = L["Copy setting from FuBar_BattlegroundFu"],
            func = function( info )
                       info.handler.db.profile = BattlegroundFu.db.profile;

                       local function DeleteAll( table )
                           for i, _ in pairs( table ) do
                               table[i] = nil;
                           end--if
                       end--function DeleteAll( table )
                       local function CopyTable( to, from )
                           for i, v in pairs( from ) do
                               if( type( v ) == "table" ) then
                                   to[i] = {};
                                   CopyTable( to[i], v );
                               else
                                   to[i] = v;
                               end--if
                           end--for
                       end--CopyTable( to, from )

                       DeleteAll( self.db.profile );
                       CopyTable( self.db.profile, BattlegroundFu.db.profile );
                       info.handler.db.profile = BattlegroundFu.db.profile;
                   end,
        };
    end--if

    self.db = LibStub( "AceDB-3.0" ):New( "Broker_BattlegroundFu2DB", defaults );

    local profileOptions = LibStub( "AceDBOptions-3.0" ):GetOptionsTable( self.db );
    
    local slashOptions = {
        type = "group",
        handler = self,
        name = options.name,
        desc = options.desc,
        icon = options.icon,
        args = {
            options = options,
            tooltip = tooltipOptions,
            profile = profileOptions,
            gui = {
                type = "execute",
                order = -1,
                name = L["Open GUI configurator"],
                desc = L["Open GUI configurator"],
                guiHidden = true,
                func = function( info )
                           InterfaceOptionsFrame_OpenToCategory( L[info.handler.name] );
                       end,
            },
        },
    };

--    self.db.RegisterCallback( self, "OnProfileChanged" );
--    self.db.RegisterCallback( self, "OnProfileReset" );

    LibStub( "AceConfig-3.0" ):RegisterOptionsTable( L["BattlegroundFu"], slashOptions, { L["BattlegroundFu"], L["batfu"] } );
    AceConfigReg:RegisterOptionsTable( "Broker_BattlegroundFu Main Options", options );
    AceConfigReg:RegisterOptionsTable( "Broker_BattlegroundFu Tooltip", tooltipOptions );
    AceConfigReg:RegisterOptionsTable( "Broker_BattlegroundFu Profile", profileOptions );
    AceConfigDialog:AddToBlizOptions( "Broker_BattlegroundFu Main Options", L["BattlegroundFu"] );
    AceConfigDialog:AddToBlizOptions( "Broker_BattlegroundFu Tooltip", L["Tooltip Options"], L["BattlegroundFu"] );
    AceConfigDialog:AddToBlizOptions( "Broker_BattlegroundFu Profile", L["Profile"], L["BattlegroundFu"] );

    self.ldbobj = LibStub( "LibDataBroker-1.1" ):NewDataObject( L["BattlegroundFu"], {
            type = "data source",
            icon = "Interface\\AddOns\\Broker_BattlegroundFu\\icons\\IconAlliance",
            label = L["BattlegroundFu"],
            text = L["No Queues"],
            OnClick = function( _, button )
                          self:OnClick( button );
                      end,
            OnEnter = function( frame )
                          local tooltip = qtip:Acquire( "Broker_BattlegroundFu_Tooltip", 3, "LEFT", "CENTER", "RIGHT" );

                          self.vars.frame = frame;
                          self.vars.tooltip = tooltip;
                          tooltip:EnableMouse( true );                          
                          self:UpdateTooltip();
                          tooltip:SmartAnchorTo( frame );
                          tooltip:Show();
                      end,
            OnLeave = function( frame )
                          local function HideTooltip( test )
                              if( MouseIsOver( self.vars.tooltip ) ) then
                                  return;
                              end;
                              self.vars.tooltip:SetScript( "OnLeave", nil );
                              qtip:Release( self.vars.tooltip );
                              self.vars.tooltip = nil;
                          end--HideTooltip()

                          if( MouseIsOver( self.vars.tooltip ) ) then
                              self.vars.tooltip:SetScript( "OnLeave", HideTooltip );
                          else
                              HideTooltip();
                          end--if
                      end,                      
        } );
end--Broker_BattlegroundFu:OnInitialize()

function Broker_BattlegroundFu:OnEnable()
    self:RegisterEvent( "UPDATE_BATTLEFIELD_STATUS" );
    self:RegisterEvent( "UPDATE_WORLD_STATES", "UpdateTooltip" );
    self:RegisterEvent( "PLAYER_DEAD" );

    self.timerHandle = self:ScheduleRepeatingTimer( self.Update, 1, self );

    if( self:IsHidingBattleFrame() ) then
        WorldStateAlwaysUpFrame:Hide();
    end--if
    if( self:IsHidingMinimapButton() ) then
        MiniMapBattlefieldFrame:Hide();
    end--if
end--Broker_BattlegroundFu:OnEnable()

function Broker_BattlegroundFu:OnDisable()
    self:CancelTimer( self.timerHandle );
    self.timerHandle = nil;
    self:UnregisterAllEvents();
    WorldStateAlwaysUpFrame:Show();
end--Broker_BattlegroundFu:OnDisable()

function Broker_BattlegroundFu:OnMenuRequest( level, value, inTooltip )
    local hasQueue = false;

    if( level == 1 ) then
        for i = 1, MAX_BATTLEFIELD_QUEUES do
            local i = i;
            local status, mapName = GetBattlefieldStatus( i );

            if( ( status == "queued" ) or ( status == "confirm" ) ) then
                hasQueue = true;
                Dewdrop:AddLine( "" );
                Dewdrop:AddLine(
                    "text", mapName,
                    "textR", 1,
                    "textG", 0.843,
                    "textB", 0,
                    "arg1", self,
                    "arg2", mapName,
                    "func", "ToggleHidingQueueText",
                    "checked", not self:IsHidingQueueText( mapName ) );
                if( status == "queued" ) then
                    Dewdrop:AddLine(
                        "text", CHANGE_INSTANCE,
                        "func", function ()
                                    ShowBattlefieldList( i );
                                end );
                elseif( status == "confirm" ) then
                    Dewdrop:AddLine(
                        "text", ENTER_BATTLE,
                        "func", function ()
                                    AcceptBattlefieldPort( i, 1 );
                                end );
                end--if
                Dewdrop:AddLine(
                    "text", LEAVE_QUEUE,
                    "func", function ()
                                AcceptBattlefieldPort( i );
                                if( not IsShiftKeyDown() ) then
                                    Dewdrop:Close( 1 );
                                end--if
                            end );
            end--if
        end--for
        Dewdrop:AddLine( "" );
        Dewdrop:AddLine(
            "text", L["Options"],
            "func", function ()
                        Dewdrop:Close( 1 );
                        InterfaceOptionsFrame_OpenToCategory( L["BattlegroundFu"] );
                    end );
    end--if
end--Broker_BattlegroundFu:OnMenuRequest( level, value, inTooltip )

local j = 1;
function Broker_BattlegroundFu:OnClick( button )
    if( button == "RightButton" ) then
        if( self.vars.tooltip ) then
            self.vars.tooltip:SetScript( "OnLeave", nil );
            qtip:Release( self.vars.tooltip );
            self.vars.tooltip = nil;
        end--if
        Dewdrop:Register( "Broker_BattlegroundFu",
            "children", function( level, value, valueN_1, valueN_2, valueN_3, valueN_4 )
                            if( level == 1 ) then
                                Dewdrop:AddLine(
                                    "text", L["BattlegroundFu"],
                                    "isTitle", true );
                                self:OnMenuRequest( level, value, false, valueN_1, valueN_2, valueN_3, valueN_4 );
                                Dewdrop:AddLine(
                                    "text", CLOSE,
                                    "tooltipTitle", CLOSE,
                                    "tooltipText", CLOSE_DESC,
                                    "func", Dewdrop.Close,
                                    "arg1", Dewdrop );
                            else
                                self:OnMenuRequest( level, value, false, valueN_1, valueN_2, valueN_3, valueN_4 );
                            end--if
                        end,
            "point", function( frame )
                         local x, y = self.vars.frame:GetCenter();
                         local leftRight;
    
                         if( x < GetScreenWidth() / 2 ) then
                             leftRight = "LEFT";
                         else
                             leftRight = "RIGHT";
                         end--if
                         if( y < GetScreenHeight() / 2 ) then
                             return "BOTTOM" .. leftRight, "TOP" .. leftRight;
                         else
                             return "TOP" .. leftRight, "BOTTOM" .. leftRight;
                         end--if
                    end,
            "dontHook", true );

        Dewdrop:Open( "Broker_BattlegroundFu", "cursorX", true, "cursorY", true );
        return;
    end--if
    if( IsShiftKeyDown() ) then
        ToggleBattlefieldMinimap();
    elseif( IsControlKeyDown() and Glory:IsInArena() ) then
        LeaveBattlefield();
    elseif( ( Glory:IsInBattlegrounds() or Glory:IsInArena() ) and self:IsClickShowsScoreboard() ) then
        if( WorldStateScoreFrame:IsVisible() ) then
            HideUIPanel( WorldStateScoreFrame );
        else
            ShowUIPanel( WorldStateScoreFrame );
        end--if
    elseif( GetBattlefieldStatus( j ) == "active" ) then
        ShowUIPanel(WorldStateScoreFrame)
        j = j + 1;
    elseif( ( GetBattlefieldStatus( j ) == "queued" ) or ( GetBattlefieldStatus( j ) == "confirm" ) ) then
        HideUIPanel( WorldStateScoreFrame );
        ShowBattlefieldList( j );
        j = j + 1;
    else
        HideUIPanel( WorldStateScoreFrame );
        HideUIPanel( BattlefieldFrame );
        j = 1;
    end--if
end--Broker_BattlegroundFu:OnClick()

function Broker_BattlegroundFu:UpdateDisplay()
    self:OnDataUpdate();
    self:OnTextUpdate();
end--Broker_BattlegroundFu:UpdateDisplay()

function Broker_BattlegroundFu:Update()
    self:OnDataUpdate();
    self:OnTextUpdate();
end--Broker_BattlegroundFu:Update()

function Broker_BattlegroundFu:OnDataUpdate()
    if( Glory:IsInBattlegrounds() ) then
        RequestBattlefieldScoreData();
    end--if
end--Broker_BattlegroundFu:OnDataUpdate()

local icon = nil;
local function UpdateText_PlayerStats()
    local red, green, white = Crayon.COLOR_HEX_RED, Crayon.COLOR_HEX_GREEN, Crayon.COLOR_HEX_WHITE;

    icon = FACTION_ICON_PATH .. playerFaction;
    return ("#: |cff%s%s|r KB: |cff%s%s|r K: |cff%s%s|r D: |cff%s%s|r H: |cff%s%s|r"):format( white, Glory:GetStanding(), green, Glory:GetKillingBlows(), green, Glory:GetHonorableKills(), red, Glory:GetDeaths(), white, Glory:GetBonusHonor() );
end--UpdateText_PlayerStats()

-- goes in here when you've not yet clicked enter
function Broker_BattlegroundFu:UpdateText_QueuedBattlefields()
    local usingDefaultText, defText;
    local queueText = L["No Queues"];
    local numQueues = 0;

    for i = 1, MAX_BATTLEFIELD_QUEUES do
        local status, mapName = GetBattlefieldStatus( i );

        if( ( status == "queued" ) or ( status == "confirm" ) ) then
            numQueues = numQueues + 1;
            if( not self:IsHidingQueueText( mapName ) ) then
                local progress;

                if( status == "queued" ) then
                    local bgTimeQueued = GetBattlefieldTimeWaited( i ) / 1000;
                    local bgEstimatedTime = GetBattlefieldEstimatedWaitTime( i ) / 1000;
                    local timeColor = Crayon:GetThresholdHexColor( 1 - bgTimeQueued/bgEstimatedTime, -0.25, -0.1, 0.1, 0.5, 0.9 );

                    progress = self:IsInvertQueueProgress() and
                        ("|cff%s%s|r/%s"):format( timeColor, Abacus:FormatDurationFull( bgEstimatedTime - bgTimeQueued, nil, 1 ), Abacus:FormatDurationFull( bgEstimatedTime, nil, 1 ) ) or
                        ("|cff%s%s|r/%s"):format( timeColor, Abacus:FormatDurationFull( bgTimeQueued, nil, 1 ), Abacus:FormatDurationFull(bgEstimatedTime, nil, 1 ) );
                else
                    local bgPortExpiration = GetBattlefieldPortExpiration( i ) / 1000;
                    local timeColor = Crayon:GetThresholdHexColor( bgPortExpiration / 120 );

                    progress = ("|cff%s%s:%s|r"):format( timeColor, L["Confirm"], Abacus:FormatDurationCondensed( bgPortExpiration ) );
                end--if
                defText = usingDefaultText or ( queueText == L["No Queues"] );
                queueText = defText and
                    ( Glory:GetBGAcronym( mapName ) .. ": " .. progress ) or
                    ( queueText .. " || " ..  Glory:GetBGAcronym( mapName ) .. ": " .. progress );
                usingDefaultText = false;
            end--if
            defText = usingDefaultText or ( queueText == L["No Queues"] );
            queueText = defText and ("%s: %d"):format( L["Queues"], numQueues ) or queueText;
            usingDefaultText = defText;
        end--if
    end--for
    icon = FACTION_ICON_PATH .. playerFaction;
    if( numQueues == 0 ) then
        icon = icon .. NOQUEUE_ICON_SUFFIX;
        if( not self:IsNoQueueText() ) then
            queueText = "";
        end--if
    end--if
    return queueText;
end--Broker_BattlegroundFu:UpdateText_QueuedBattlefields()

function Broker_BattlegroundFu:OnTextUpdate()
    local barText;

    if( Glory:IsInBattlegrounds() and Glory:GetStanding() ) then
        local status, queueText;

        for i = 1, MAX_BATTLEFIELD_QUEUES do
            status = GetBattlefieldStatus( i );
            if( ( status == "queued" ) or ( status == "confirm" ) ) then
                queueText = self:UpdateText_QueuedBattlefields();
                break;
            end--if
        end--for
        if( queueText ) then
            barText = UpdateText_PlayerStats() .. " | " .. queueText;
        else
            barText = UpdateText_PlayerStats();
        end--if
    else
        barText = self:UpdateText_QueuedBattlefields()
    end
    self.ldbobj.text = barText;
    self.ldbobj.icon = icon;
end--Broker_BattlegroundFu:OnTextUpdate()

function Broker_BattlegroundFu:UpdateTooltip_BattlefieldMatchInfo( label, textA, textH )
    local aR, aG, aB = Glory:GetFactionColor( FACTION_ALLIANCE );
    local hR, hG, hB = Glory:GetFactionColor( FACTION_HORDE );
    local line, column;
    local tooltip = self.vars.tooltip;

    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, label, tooltip:GetHeaderFont(), nil, tooltip:GetColumnCount() );
    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, ("|cff%02x%02x%02x%s|r"):format( aR * 255, aG * 255, aB * 255, textA ) );
    line, column = tooltip:SetCell( line, column, label );
    line, column = tooltip:SetCell( line, column, ("|cff%02x%02x%02x%s|r"):format( hR * 255, hG * 255, hB * 255, textH ) );
end--Broker_BattlegroundFu:UpdateTooltip_BattlefieldMatchInfo( label, textA, textH )

function Broker_BattlegroundFu:UpdateTooltip_PlayerStats()
    local fontSave = self.vars.tooltip:GetFont();
    local standing = Glory:GetStanding();
    local tooltip = self.vars.tooltip;
    local kbs = Glory:GetKillingBlows();
    local hks = Glory:GetHonorableKills();
    local deaths = Glory:GetDeaths();
    local honor = Glory:GetBonusHonor();
    local line, column;

    line, column = tooltip:AddHeader( L["Player Stats"] );
    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, "|cffffd600" .. L["Standing"] .. "|r", nil, nil, -1 );
    line, column = tooltip:SetCell( line, column, "|cffffffff" .. standing .. "|r" );

    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, "|cffffd600" .. L["Killing Blows"] .. "|r", nil, nil, -1 );
    line, column = tooltip:SetCell( line, column, "|cff00ff00" .. kbs .. "|r" );

    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, "|cffffd600" .. L["Kills"] .. "|r", nil, nil, -1 );
    line, column = tooltip:SetCell( line, column, "|cff00ff00" .. hks .. "|r" );
    
    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, "|cffffd600" .. L["Deaths"] .. "|r", nil, nil, -1 );
    line, column = tooltip:SetCell( line, column, "|cffff0000" .. deaths .. "|r" );
    
    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, "|cffffd600" .. L["Bonus Honor"] .. "|r", nil, nil, -1 );
    line, column = tooltip:SetCell( line, column, "|cffffffff" .. honor .. "|r" );
end--Broker_BattlegroundFu:UpdateTooltip_PlayerStats()

function Broker_BattlegroundFu:UpdateTooltip_BattlefieldObjectiveTimers( showUncontested )
    if( Glory.battlefieldObjectiveStatus and next( Glory.battlefieldObjectiveStatus ) ) then
        local tooltip = self.vars.tooltip;
        local line, column;

        line, column = tooltip:AddLine();
        line, column = tooltip:SetCell( line, column, L["Base"], tooltip:GetHeaderFont(), nil, nil, -1 );
        line, column = tooltip:SetCell( line, column, L["Status"], tooltip:GetHeaderFont() );

        for _, poi in Glory:IterateSortedObjectiveNodes() do
            local lR, lG, lB = Glory:GetFactionColor( Glory:GetDefender( poi ) );
            local rR, rG, rB = Glory:GetFactionColor( Glory:GetDefender( poi ) );
            local factionAttacking = nil;
            local node = Glory:GetName( poi );
            local status;

            if( Glory:IsInConflict( poi ) ) then
                factionAttacking = Glory:GetAttacker( poi );
                rR, rG, rB = Glory:GetFactionColor( factionAttacking );
                factionAttacking = ( factionAttacking == FACTION_ALLIANCE ) and "A" or "H";
                if( Glory:GetTimeAttacked( poi ) ) then
                    status = Abacus:FormatDurationCondensed( Glory:GetTimeToCapture( poi ) );
                else        --when joining a battlefield where the node is already under attack
                    status = L["In Conflict"];
                end--if
            elseif( Glory:IsDestroyed( poi ) ) then
                status = L["Destroyed"];
            else
                status = Glory:GetDefender( poi );
            end--if
            
            if( showUncontested or Glory:IsInConflict( poi ) ) then
                line, column = tooltip:AddLine();
                line, column = tooltip:SetCell( line, column, ("|cff%02x%02x%02x%s|r"):format( lR * 255, lG * 255, lB * 255, node ), nil, nil, -1, ObjectiveClickProvider, factionAttacking, node, status );
                line, column = tooltip:SetCell( line, column, ("|cff%02x%02x%02x%s|r"):format( rR * 255, rG * 255, rB * 255, status ), nil, nil, nil, ObjectiveClickProvider, factionAttacking, node, status );
            end--if
        end--for
    end--if
end--Broker_BattlegroundFu:UpdateTooltip_BattlefieldObjectiveTimers( showUncontested )

function Broker_BattlegroundFu:UpdateTooltip_CTFFlagCarriers()
    local aR, aG, aB = Glory:GetFactionColor( FACTION_ALLIANCE );
    local hR, hG, hB = Glory:GetFactionColor( FACTION_HORDE );
    local carrier = Glory:GetHordeFlagCarrier();
    local rR, rG, rB;
    local line, column;
    local tooltip = self.vars.tooltip;

    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, L["Flag"], tooltip:GetHeaderFont(), nil, nil, -1 );
    line, column = tooltip:SetCell( line, column, L["Carrier"], tooltip:GetHeaderFont() );

    if( carrier ) then
        rR, rG, rB = Glory:GetFactionColor( FACTION_HORDE );
    else
        rR, rG, rB = Glory:GetFactionColor( FACTION_ALLIANCE );
    end--if
    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, ("|cff%02x%02x%02x%s|r"):format( aR * 255, aG * 255, aB * 255, FACTION_ALLIANCE ), nil, nil, -1 );
    line, column = tooltip:SetCell( line, column, ("|cff%02x%02x%02x%s|r"):format( rR * 255, rG * 255, rB * 255, carrier or L["N/A"] ) );
    carrier = Glory:GetAllianceFlagCarrier();
    if( carrier ) then
        rR, rG, rB = Glory:GetFactionColor( FACTION_ALLIANCE );
    else
        rR, rG, rB = Glory:GetFactionColor( FACTION_HORDE );
    end--if
    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, ("|cff%02x%02x%02x%s|r"):format( hR * 255, hG * 255, hB * 255, FACTION_HORDE ), nil, nil, -1 );
    line, column = tooltip:SetCell( line, column, ("|cff%02x%02x%02x%s|r"):format( rR * 255, rG * 255, rB * 255, carrier or L["N/A"] ) );
end--UpdateTooltip_CTFFlagCarriers()

local ttOpenBattlefieldFrame;
local QueuesClickProvider, QueuesClickPrototype, baseQueuesClickCellPrototype = qtip:CreateCellProvider( qtip.LabelProvider );

function QueuesClickProvider:InitializeCell()
    baseQueuesClickCellPrototype.InitializeCell( self );
end--QueuesClickProvider:InitializeCell()

function QueuesClickPrototype:SetupCell( tooltip, value, justification, font, i )
    self:EnableMouse( true );
    self:SetScript( "OnEnter", function( self )
                                   if( not self.highlight ) then
                                       self.highlight = self:CreateTexture( nil, "BACKGROUND" );
                                       self.highlight:Hide();
                                   end--if
                                   self.highlight:SetTexture( "Interface\\QuestFrame\\UI-QuestTitleHighlight" );
                                   self.highlight:SetBlendMode( "ADD" );
                                   self.highlight:SetAllPoints( self );
                                   self.highlight:Show();
                               end );
    self:SetScript( "OnLeave", function( self )
                                   self.highlight:ClearAllPoints();
                                   self.highlight:Hide();
                               end );
    self:SetScript( "OnMouseDown", function()
                                       if( ( not BattlefieldFrame:IsVisible() ) or ( ttOpenBattlefieldFrame ~= i ) ) then
                                           ShowBattlefieldList( i );
                                           ttOpenBattlefieldFrame = i;
                                       else
                                           HideUIPanel( BattlefieldFrame );
                                       end--if
                                   end );
    return baseQueuesClickCellPrototype.SetupCell( self, tooltip, value, justification, font );
end--QueuesClickPrototype:SetupCell( tooltip, value, justification, font )

function Broker_BattlegroundFu:UpdateTooltip_BGQueues( invert )
    local tooltip = self.vars.tooltip;
    local line, column;

    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, L["Battlefields Queued"], invert and L["Remaining"] or L["Progress"], tooltip:GetHeaderFont(), nil, -1 );
    line, column = tooltip:SetCell( line, column, invert and L["Remaining"] or L["Progress"], tooltip:GetHeaderFont() );

    for i = 1, MAX_BATTLEFIELD_QUEUES do
        local i = i;
        local status, mapName = GetBattlefieldStatus( i );

        if( status == "queued" ) then
            local bgTimeQueued = GetBattlefieldTimeWaited( i ) / 1000;
            local bgEstimatedTime = GetBattlefieldEstimatedWaitTime( i ) / 1000;
            local timeR, timeG, timeB = Crayon:GetThresholdColor( 1 - bgTimeQueued / bgEstimatedTime, -0.25, -0.1, 0.1, 0.5, 0.9 );
            local progress = invert and
                Abacus:FormatDurationCondensed( bgEstimatedTime - bgTimeQueued ) .. "|r|cffffd700/" .. Abacus:FormatDurationCondensed( bgEstimatedTime ) or
                Abacus:FormatDurationCondensed( bgTimeQueued ) .. "|r|cffffd700/" .. Abacus:FormatDurationCondensed( bgEstimatedTime );

            line, column = tooltip:AddLine();
            line, column = tooltip:SetCell( line, column, "|cffffd600" .. mapName .. "|r", nil, nil, -1, QueuesClickProvider, i );
            line, column = tooltip:SetCell( line, column, ("|cff%02x%02x%02x%s|r"):format( timeR * 255, timeG * 255, timeB * 255, progress ), nil, nil, nil, QueuesClickProvider, i );
        end--if
        if( status == "confirm" ) then
            local bgPortExpiration = GetBattlefieldPortExpiration( i ) / 1000;
            local timeR, timeG, timeB = Crayon:GetThresholdColor( bgPortExpiration / 120 );
            local progress = L["Confirm"] .. ":" .. Abacus:FormatDurationCondensed( bgPortExpiration );

            line, column = tooltip:AddLine();
            line, column = tooltip:SetCell( line, column, "|cffffd600" .. mapName .. "|r", nil, nil, -1, QueuesClickProvider, i );
            line, column = tooltip:SetCell( line, column, ("|cff%02x%02x%02x%s|r"):format( timeR * 255, timeG * 255, timeB * 255, progress ), nil, nil, nil, QueuesClickProvider, i );
        end--if
    end--for
end--Broker_BattlegroundFu:UpdateTooltip_BGQueues( invert )

function Broker_BattlegroundFu:OnTooltipUpdate()
    local status, mapName, instanceID;
    local line, column;
    local tooltip = self.vars.tooltip;

    tooltip:Clear();
    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, L["BattlegroundFu"], tooltip:GetHeaderFont(), nil, tooltip:GetColumnCount() );
    if( Glory:IsInBattlegrounds() ) then
        line, column = tooltip:AddLine();
        line, column = tooltip:SetCell( line, column, Glory:GetActiveBattlefieldUniqueID(), nil, nil, tooltip:GetColumnCount() );
        if( self:IsShowingTeamSizes() ) then
            self:UpdateTooltip_BattlefieldMatchInfo( L["Players"], Glory:GetNumAlliancePlayers(), Glory:GetNumHordePlayers() );
        end--if
        if( self:IsShowingTeamScores() and GetWorldStateUIInfo( 1 ) ) then
            self:UpdateTooltip_BattlefieldMatchInfo( L["Score"], Glory:GetAllianceScoreString(), Glory:GetHordeScoreString() );
        end--if

        local _, _, s = GetWorldStateUIInfo( 1 );

        if( self:IsShowingNumBases() and s and s:find( L["Bases"] ) ) then
            self:UpdateTooltip_BattlefieldMatchInfo( L["Bases"], Glory:GetNumAllianceBases(), Glory:GetNumHordeBases() )
        end--if
        if( self:IsShowingResourceTTV() and s and s:find( L["Resources"] ) ) then
            self:UpdateTooltip_BattlefieldMatchInfo( L["TTV"], Abacus:FormatDurationCondensed( Glory:GetAllianceTTV() ), Abacus:FormatDurationCondensed( Glory:GetHordeTTV() ) );
        end--if
        if( self:IsShowingPlayerStats() ) then
            self:UpdateTooltip_PlayerStats();
        end--if
        if( ( GetNumMapLandmarks() > 0 ) and self:IsShowingObjectiveStatus() ) then
            self:UpdateTooltip_BattlefieldObjectiveTimers( self:IsShowingUncontestedObjectives() );
        end--if
        if( self:IsShowingCTFFlagCarriers() and ( Glory:GetActiveBattlefieldZone() == Z["Warsong Gulch"] ) ) then
            self:UpdateTooltip_CTFFlagCarriers();
        end--if
    elseif( Glory:IsInArena() ) then
        -- Show arena information
        local started, rated = IsActiveBattlefieldArena();
        
        if( started ) then
            if( rated ) then
                line, column = tooltip:AddLine();
                line, column = tooltip:SetCell( line, 1, L["Rated arena match"], nil, nil, tooltip:GetColumnCount() );
            else
                line, column = tooltip:AddLine();
                line, column = tooltip:SetCell( line, 1, L["Unrated arena match"], nil, nil, tooltip:GetColumnCount() );
            end--if
        else
            line, column = tooltip:AddLine();
            line, column = tooltip:SetCell( line, 1, L["Waiting for match start..."], nil, nil, tooltip:GetColumnCount() );
        end--if
    end--if

    if( self:IsShowingQueues() ) then
        local invert = self:IsInvertQueueProgress();

        for i = 1, MAX_BATTLEFIELD_QUEUES do
            status = GetBattlefieldStatus( i );
            if( ( status == "queued" ) or ( status == "confirm" ) ) then
                self:UpdateTooltip_BGQueues( invert );
                break;
            end--if
        end--for
    end--if

    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, " ", nil, nil, tooltip:GetColumnCount() );
    line, column = tooltip:AddLine();
    line, column = tooltip:SetCell( line, column, Glory:IsInBattlegrounds() or Glory:IsInArena() and
          ("%s\n%s"):format( ( ( self:IsClickShowsScoreboard() and L["Click to toggle scoreboard display."] ) or L["Click to cycle through Scoreboard/Battlefield List frames."] ), L["Shift-Click to toggle battle map."] ) or
          " ", nil, nil, tooltip:GetColumnCount() );
end--Broker_BattlegroundFu:OnTooltipUpdate()


function Broker_BattlegroundFu:UpdateTooltip()
    if( self.vars.tooltip ) then
        self:OnTooltipUpdate();
    end--if
end--Broker_RecZone:UpdateTooltip()
--End FuBar Standard Methods===================================================

--Game Events==================================================================
function Broker_BattlegroundFu:UPDATE_BATTLEFIELD_STATUS()
    if( self:IsHidingMinimapButton() and MiniMapBattlefieldFrame:IsVisible() ) then
        MiniMapBattlefieldFrame:Hide();
    end--if
    self:UpdateDisplay();
end--Broker_BattlegroundFu:UPDATE_BATTLEFIELD_STATUS()

function Broker_BattlegroundFu:PLAYER_DEAD()
    if( Glory:IsInBattlegrounds() and ( not HasSoulstone() ) and self:IsAutoReleasing() ) then
        RepopMe();
    end--if
end--Broker_BattlegroundFu:PLAYER_DEAD()
--End Game Events==============================================================
